import sys
sys.path.append('./libraries')
import time
from amoled_1inch43 import CO5300, FT6146

LCD_WIDTH = 466
LCD_HEIGHT = 466
def display_clear(display, color):
    display.set_windows(0, 0, display.width - 1, display.height - 1)
    buffer = bytearray(display.width * 2)
    for i in range(len(buffer) / 2):
        buffer[2 * i] = color >> 8
        buffer[2 * i + 1] = color & 0xff
    for i in range(display.height):
        display.flush(buffer)

if __name__ == '__main__':
    display = CO5300(width = LCD_WIDTH, height = LCD_HEIGHT, offset_x = 6)
    display_clear(display, 0xf800)
    display.set_brightness(255)
    while True:
        display_clear(display, 0xf800)
        time.sleep(2)
        display_clear(display, 0x07e0)
        time.sleep(2)
        display_clear(display, 0x001f)
        time.sleep(2)